
class hm_slope {
  N1 = 4
  N2 = 8
  S1 = 36
  S2 = 72
  E1 = 28
  E2 = 56
  W1 = 12
  W2 = 24
  UP = 82
  //UP2 = 92
  DOWN = 83
  //DN2 = 93
}

function hm_get_desc(waytype,name) {
  local sts = [st_flat, st_elevated, st_tram]
  foreach (st in sts) {
    local desc_all = way_desc_x.get_available_ways(waytype, st)
    foreach (desc in desc_all) {
      if(desc.get_name()==name) {
        return desc
      }
    }
  }
  return null
}

local hm_commands = [] // array to store the commands

class hm_base_tl {
  function exec(player, origin) {
    return null
  }
}

class hm_slope_tl extends hm_base_tl {
  slope = 0
  pos = null
  constructor(slp, p) {
    slope = slp
    pos = coord3d(p[0],p[1],p[2])
    hm_commands.append(this)
  }
  function exec(player, origin) {
    return command_x.set_slope(player, origin+pos, slope);
  }
}

class hm_way_tl extends hm_base_tl {
  desc = null
  desc_name = null
  start = null
  ziel = null
  constructor(waytype, d_name, s, z) {
    desc_name = d_name
    desc = hm_get_desc(waytype, desc_name)
    start = coord3d(s[0],s[1],s[2])
    ziel = coord3d(z[0],z[1],z[2])
    hm_commands.append(this)
  }
  function exec(player, origin) {
    if (desc==null) {
      return desc_name + " cannot be found!"
    }
    return command_x.build_way(player, origin+start, origin+ziel, desc, true)
  }
}

function work(player, pos) {
  local error_msg = null
  foreach (cmd in hm_commands) {
    local err = cmd.exec(player, pos)
    if(err!=null && err.len()>0) {
      error_msg = err
    }
  }
  return error_msg
}

function exit(pl)
{
	return true
}
